;========================================================================================
;  crtmodtest.s
;  Copyright (C) 2003-2024 Makoto Kamada
;
;  This file is part of the XEiJ (X68000 Emulator in Java).
;  You can use, modify and redistribute the XEiJ if the conditions are met.
;  Read the XEiJ License for more details.
;  https://stdkmd.net/xeij/
;========================================================================================

;----------------------------------------------------------------
;
;	crtmodtest.x
;		IOCS _CRTMOD̎ƃj^̐\mF邽߂̉ʂ\܂B
;		IPLROM 1.6/crtmod16.xŊgꂽʃ[hɑΉĂ܂B
;
;	ŏIXV
;		2024-08-26
;
;	
;		has060 -i include -o crtmodtest.o -w crtmodtest.s
;		lk -o crtmodtest.x crtmodtest.o
;
;	g
;		-l CRTorLCD[h
;			CRTorLCD[hw肵܂B
;			0w肷CRT̓gɁA1w肷LCD̓gɂȂ܂B
;			-lw肵-sw肵ȂƂCRTorLCD[hɖ߂ďI܂B
;			-lw肵-sw肵ƂCRTorLCD[hύX܂܏I܂B
;			-lw肵ȂƂ݂͌CRTorLCD[hp܂B
;			-lw肵ȂƂ-s͎wł܂B
;		-m ʃ[h
;			ʃ[h0`47͈̔͂Ŏw肵܂B
;			ʃ[ḧꗗ͎gp@ɏĂ܂B
;		-s
;			-lŎw肳ꂽCRTorLCD[hSRAMɕۑ܂B
;		ʂ\ăL[͑҂ɂȂ܂B
;		L[Ɖʃ[hɖ߂ďI܂B
;		ESCL[ꂽƂ͉ʃ[hύX܂܏I܂B
;
;	XV
;		2022-02-21
;			JB
;		2023-01-10
;			wvbZ[Wy[Wɋ؂ĕ\悤ɂ܂B
;		2023-11-14
;			-lw肵ƂCRTorLCD[hύX܂܏IĂ܂Aɖ߂ďI悤ɂ܂B
;			-sǉ܂B-sw肷-lŎw肳ꂽCRTorLCD[hɕύX܂܏I܂B
;		2024-08-25
;			ʃ[h40`47ɑΉ܂B
;		2024-08-26
;			IPLROM 1.0`1.3IOCS _SP_INIT̃oO𓥂܂Ȃ悤ɂ܂B
;			ESCL[ŏIƂAXvCgƃOtBbN\ɁAeLXgAeLXgpbg𕜌܂B
;			R[h𐮗܂B
;
;----------------------------------------------------------------

	.include	bioswork.equ
	.include	control2.mac
	.include	crtc.equ
	.include	doscall.mac
	.include	iocscall.mac
	.include	misc.mac
	.include	push2.mac
	.include	sprc.equ
	.include	sram.equ

TITLE_STRING	reg	'crtmodtest.x for IPLROM 1.6/crtmod16.x (2024-08-26)'

MAX_SCREEN_MODE	equ	47		;ʃ[h̍ől

TEXT_LINE	equ	3
GRAPHIC_LINE	equ	4		;4,5,6,7
SPRITE_LINE	equ	8
BG_LINE		equ	9		;9,10

	.text

base:
	lea.l	base(pc),a6
r	reg	-base(a6)

;IvVmF
	moveq.l	#-1,d6			;CRTorLCD[h͎w肳ĂȂ
	moveq.l	#-1,d7			;ʃ[h͎w肳ĂȂ
	sf.b	(save_to_sram)r		;CRTorLCD[hSRAMɕۑȂ
	lea.l	1(a2),a0
	dostart
		gotoand	<cmp.b #'-',d0>,ne,<cmp.b #'/',d0>,ne,usage_exit	;-,/ȊO
		addq.l	#1,a0
		move.b	(a0)+,d0
		goto	eq,usage_exit		;-,/̌ɕȂ
		bsr	tolower
		if	<cmp.b #'l',d0>,eq	;-l
			goto	<tst.l d6>,pl,usage_exit	;CRTorLCD[h͊Ɏw肳Ă
			bsr	nextword
			bsr	stou
			gotoor	<>,cs,<cmp.l #1,d0>,hi,usage_exit	;10iȂ͈͊O
			move.l	d0,d6			;CRTorLCD[hw肳ꂽ
		elif	<cmp.b #'m',d0>,eq	;-m
			goto	<tst.l d7>,pl,usage_exit	;ʃ[h͊Ɏw肳Ă
			bsr	nextword
			bsr	stou
			gotoor	<>,cs,<cmp.l #MAX_SCREEN_MODE,d0>,hi,usage_exit	;10iȂ͈͊O
			move.l	d0,d7			;ʃ[hw肳ꂽ
		elif	<cmp.b #'s',d0>,eq	;-s
			st.b	(save_to_sram)r		;CRTorLCD[hSRAMɕۑ
		else				;-l,-m,-sȊO
			goto	usage_exit
		endif
	start
		bsr	nextword
	while	ne
	goto	<tst.l d7>,mi,usage_exit	;ʃ[hw肳ĂȂ
	gotoand	<tst.l d6>,mi,<tst.b (save_to_sram)r>,ne,usage_exit	;CRTorLCD[hw肳ĂȂ̂SRAMɕۑłȂ
;<d6.l:CRTorLCD[hB0=CRT,1=LCD,-1=w肳ĂȂ
;<d7.l:ʃ[h

;X[p[oCU[hֈڍs
	supervisormode

;CRTorLCD[hۑ
	btst.b	#SRAM_XEIJ_LCD_BIT,SRAM_XEIJ
	sne.b	(saved_crtlcd)r

;ʃ[hݒ肷
	move.l	d7,d1			;ʃ[h
	if	<tst.l d6>,pl		;CRTorLCD[hw肳Ă
		if	eq			;CRT
			or.w	#$4300,d1
		else				;LCD
			or.w	#$4C00,d1
		endif
	endif
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON

;W߂
;ʃ[h
	moveq.l	#0,d0
	move.b	BIOS_CRTMOD.w,(screen_mode)r
;CRTorLCD[h
	btst.b	#SRAM_XEIJ_LCD_BIT,SRAM_XEIJ
	sne.b	(crtlcd_mode)r
;OtBbNy[W
	move.b	BIOS_GRAPHIC_PAGES.w,d0
	move.b	d0,(pages)r
;BGTCY
	move.w	SPRC_RESOLUTION,d0
	btst.l	#0,d0
	sne.b	(bg_size)r
;XvCgʂ̗L
	moveq.l	#%10010,d0
	and.w	CRTC_MODE_RESOLUTION,d0
	cmp.w	#%10010,d0
	sne.b	(sprite_exists)r
;ʂ̕
	move.w	BIOS_GRAPHIC_RIGHT.w,d0
	addq.w	#1,d0
	move.w	BIOS_CONSOLE_RIGHT.w,d1
	addq.w	#1,d1
	lsl.w	#3,d1
	if	<cmp.w d1,d0>,lo
		move.w	d1,d0
	endif
	move.w	d0,(screen_width)r
;ʂ̍
	moveq.l	#0,d0
	move.w	BIOS_GRAPHIC_BOTTOM.w,d0
	addq.l	#1,d0
	moveq.l	#0,d1
	move.w	BIOS_CONSOLE_BOTTOM.w,d1
	addq.w	#1,d1
	lsl.w	#4,d1
	if	<cmp.l d1,d0>,lo
		move.l	d1,d0
	endif
	move.w	d0,(screen_height)r
;XvCgʂ̍
	move.w	(screen_height)r,(sprite_height)r
	ifand	<cmpi.b #44,(screen_mode)r>,hs,<cmpi.b #MAX_SCREEN_MODE,(screen_mode)r>,ls
		lsl.w	(sprite_height)r	;ʃ[h44`47̓XvCgʂ̍2{ɂ
	endif
;ʃTCY
	move.l	BIOS_GRAPHIC_Y_OFFSET.w,d0
	lsr.l	#1,d0
	move.w	d0,(real_size)r
;OtBbNF
	moveq.l	#0,d0
	move.w	BIOS_GRAPHIC_PALETS.w,d0
	addq.l	#1,d0
	move.l	d0,(palets)r

;[U[h֕A
	usermode

;eLXgʂ`
;pbgݒ肷
	moveq.l	#3,d1			;pbgR[h
	move.w	(text_color)r,d2	;J[R[h
	IOCS	_TPALET
;ʃ[h\
	lea.l	(string_buffer)r,a0
	movestr	'CRTMOD(',a1
	bsr	strcpy
	moveq.l	#0,d0
	move.b	(screen_mode)r,d0
	bsr	utos
	if	<tst.b (crtlcd_mode)r>,eq
		movestr	') CRT',a1
	else
		movestr	') LCD',a1
	endif
	bsr	strcpy
	moveq.l	#3,d1			;pbgR[h
	moveq.l	#2,d2			;XW
	moveq.l	#TEXT_LINE-2,d3		;YW
	lea.l	(string_buffer)r,a1	;
	move.l	a0,d4
	sub.l	a1,d4
	subq.w	#1,d4			;-1
	IOCS	_B_PUTMES
;ʃTCY\
	lea.l	(string_buffer)r,a0
	moveq.l	#0,d0
	move.w	(screen_width)r,d0
	bsr	utos
	move.b	#'x',(a0)+
	moveq.l	#0,d0
	move.w	(screen_height)r,d0
	bsr	utos
	move.b	#'/',(a0)+
	moveq.l	#0,d0
	move.w	(real_size)r,d0
	bsr	utos
	move.b	#'x',(a0)+
	moveq.l	#0,d0
	move.w	(real_size)r,d0
	bsr	utos
	move.b	#' ',(a0)+
	move.l	(palets)r,d0
	bsr	utos
	move.b	#' ',(a0)+
	moveq.l	#0,d0
	move.b	(pages)r,d0
	bsr	utos
	moveq.l	#3,d1			;pbgR[h
	moveq.l	#2,d2			;XW
	moveq.l	#TEXT_LINE-1,d3		;YW
	lea.l	(string_buffer)r,a1	;
	move.l	a0,d4
	sub.l	a1,d4
	subq.w	#1,d4			;-1
	IOCS	_B_PUTMES
;TEXTƏ
	moveq.l	#3,d1			;pbgR[h
	moveq.l	#2,d2			;XW
	moveq.l	#TEXT_LINE,d3		;YW
	moveq.l	#8-1,d4			;-1
	movestr	'sdws',a1		;
	IOCS	_B_PUTMES

;OtBbNʂ`
;pbgݒ肷
	if	<cmp.l #65536,(palets)r>,lo
		moveq.l	#0,d1			;pbgR[h0
		moveq.l	#0,d2			;J[R[h
		IOCS	_GPALET
		lea.l	(graphic_color)r,a0
		moveq.l	#1,d3
		do
			move.w	d3,d1			;pbgR[h1`4
			move.w	(a0)+,d2		;J[R[h
			IOCS	_GPALET
			addq.w	#1,d3
		while	<cmp.w #4,d3>,ls
	endif
;g`
	move.w	#$F0F0,-(sp)		;CX^C
	moveq.l	#1,d0
	if	<cmp.l #65536,(palets)r>,eq
		move.w	(graphic_color)r,d0
	endif
	move.w	d0,-(sp)		;pbgR[h
	move.w	(screen_height)r,d0
	subq.w	#1,d0
	move.w	d0,-(sp)		;I_YW
	move.w	(screen_width)r,d0
	subq.w	#1,d0
	move.w	d0,-(sp)		;I_XW
	clr.w	-(sp)			;n_YW
	clr.w	-(sp)			;n_XW
	moveq.l	#2-1,d1			;O,
	for	d1
		movea.l	sp,a1
		IOCS	_BOX
		addq.w	#4,(sp)			;n_XW
		addq.w	#4,2(sp)		;n_YW
		subq.w	#4,4(sp)		;I_XW
		subq.w	#4,6(sp)		;I_YW
	next
	lea.l	12(sp),sp
;GRAPHIC PAGE 0/1/2/3Ə
	moveq.l	#0,d5			;y[Wԍ 0,1,2,3
	do
	;
		lea.l	(string_buffer)r,a0
		movestr	'fq`oghb@o`fd@',a1
		bsr	strcpy
		move.w	#'O',d0
		add.w	d5,d0
		rol.w	#8,d0
		move.b	d0,(a0)+
		rol.w	#8,d0
		move.b	d0,(a0)+
		clr.b	d0
	;y[WI
		move.l	d5,d1
		IOCS	_APAGE
	;`
		move.w	#1<<8|0,-(sp)		;TCY:px
		moveq.l	#1,d0
		add.w	d5,d0
		if	<cmp.l #65536,(palets)r>,eq
			move.w	d5,d0
			lea.l	(graphic_color)r,a0
			add.w	d0,d0
			move.w	(a0,d0.w),d0
		endif
		move.w	d0,-(sp)		;pbgR[h
		move.w	#1<<8|1,-(sp)		;X̔{:Y̔{
		pea.l	(string_buffer)r	;
		moveq.l	#GRAPHIC_LINE,d0
		add.w	d5,d0
		lsl.w	#4,d0
		move.w	d0,-(sp)		;YW
		move.w	#8*2,-(sp)		;XW
		movea.l	sp,a1
		IOCS	_SYMBOL
		lea.l	14(sp),sp
		addq.w	#1,d5
	while	<cmp.b (pages)r,d5>,lo

;XvCgʂ`
	if	<tst.b (sprite_exists)r>,ne	;XvCgʂ
	;
		IOCS	_SP_INIT
		IOCS	_SP_ON
	;pbgݒ肷
		lea.l	(sprite_color)r,a0
		moveq.l	#1,d4			;pbgubN 1,2,3
		do
			moveq.l	#0,d1			;pbgR[h
			move.l	d4,d2			;pbgubN
			moveq.l	#0,d3			;J[R[h
			IOCS	_SPALET
			moveq.l	#1,d1			;pbgR[h
			move.l	d4,d2			;pbgubN
			move.w	(a0)+,d3		;J[R[h
			IOCS	_SPALET
			addq.w	#1,d4
		while	<cmp.w #3,d4>,ls
	;}`p^[`
		moveq.l	#2,d1			;p^[ԍ 2
		moveq.l	#1,d2			;TCY 16x16
		lea.l	(sprite_pattern)r,a1	;XvCgp^[
		IOCS	_SP_DEFCG		;p^[`
	;p^[`
	;		  3 4 5 6 7 8 910111213141516171819202122
		movestr	'roqhsda`bj|fqntmc@OP',a4
		moveq.l	#3,d6			;p^[ԍ
		dostart
			lsl.w	#8,d1
			move.b	(a4)+,d1		;R[h
			moveq.l	#8,d2			;TCY 16x16
			lea.l	(font_buffer)r,a1	;tHgobt@
			IOCS	_FNTGET			;tHgf[^o
			lea.l	(pattern_buffer)r,a0	;p^[obt@
			moveq.l	#0,d7			;0Œ
			moveq.l	#-2,d5			;-2=,-1=E
			do
				lea.l	(font_buffer+4)r,a1	;tHgf[^̖{
				moveq.l	#16-1,d3		;c16hbg
				for	d3
				;	moveq.l	#0,d0
					move.b	2(a1,d5.w),d1		;܂͉E
					moveq.l	#8-1,d2			;8hbg
					for	d2
						lsl.l	#4,d0			;00000ɁA10001ɂ
						add.b	d1,d1			;d1.b̏ʂ牟o
						addx.b	d7,d0			;d0.l̉ʂ։
					next
					move.l	d0,(a0)+		;p^[f[^
					addq.l	#2,a1
				next
				addq.w	#1,d5
			while	ne
			move.w	d6,d1			;p^[ԍ
			moveq.l	#1,d2			;TCY 16x16
			lea.l	(pattern_buffer)r,a1	;p^[f[^
			IOCS	_SP_DEFCG		;p^[`
			addq.w	#1,d6			;̃p^[ԍ
		start
			moveq.l	#0,d1
			move.b	(a4)+,d1		;R[h
		while	ne
	;l̃XvCg\
		moveq.l	#0,d6			;ʒu=XvCgԍ 0=,1=E,2=,3=E
		do
			move.l	d6,d1			;XvCgԍ 0,1,2,3
			moveq.l	#16,d2			;XW[
			if	<btst.l #0,d6>,ne
				move.w	(screen_width)r,d2	;XWE[
			endif
			moveq.l	#16,d3			;YW[
			if	<btst.l #1,d6>,ne
				move.w	(sprite_height)r,d3	;YW[
			endif
			move.w	#1<<8|2,d4		;pbgubN:p^[ԍ 1:2
			moveq.l	#3,d5			;vCIeB 3
			IOCS	_SP_REGST
			addq.w	#1,d6			;̈ʒu=XvCgԍ
		while	<cmp.w #3,d6>,ls
	;SPRITEƏ
		moveq.l	#16+16*1,d2
		movea.l	d2,a2			;XW
		moveq.l	#SPRITE_LINE,d3
		move.w	(screen_height)r,d0
		if	<cmp.w (sprite_height)r,d0>,ne
			add.w	d3,d3
		endif
		lsl.w	#4,d3
		add.w	#16,d3
		movea.l	d3,a3			;YW
	;		 S P R I T E
		movestr	<3,4,5,6,7,8>,a4	;p^[ԍ
		moveq.l	#4,d7			;XvCgԍ
		dostart
			move.l	d7,d1			;XvCgԍ
			move.w	a2,d2			;XW
			move.w	a3,d3			;YW
			move.w	#1<<8,d4
			move.b	d0,d4			;pbgubN:p^[ԍ
			moveq.l	#3,d5			;vCIeB 3
			IOCS	_SP_REGST
			addq.w	#1,d7			;̃XvCgԍ
			adda.w	#16,a2			;XW
		start
			moveq.l	#0,d0
			move.b	(a4)+,d0		;p^[ԍ
		while	ne
	;BG`
		if	<tst.b (bg_size)r>,eq	;8x8/512x512x2
			moveq.l	#0,d5			;BGeLXgGA 0,1
			do
			;g̃p^[`
				move.l	d5,d1
				addq.w	#2,d1			;p^[ԍ 2,3
				moveq.l	#0,d2			;TCY 8x8
				lea.l	(bg_pattern_8x8)r,a1
				move.l	d5,d0
				lsl.w	#5,d0
				adda.l	d0,a1			;p^[f[^
				IOCS	_SP_DEFCG
			;g̃p^[œhׂ
				move.l	d5,d1			;BGeLXgGA 0,1
				move.l	d5,d2
				addq.w	#2,d2			;p^[ԍ=pbgubN 2,3
				move.b	d2,d0
				lsl.w	#8,d2
				move.b	d0,d2			;pbgubN:p^[ԍ 2:2,3:3
				IOCS	_BGTEXTCL
			;gcē蔲
				move.l	d5,d1			;BGeLXgGA 0,1
				moveq.l	#0<<8|0,d4		;pbgubN:p^[ԍ 0:0
				moveq.l	#1,d3			;BGeLXgYWBg1
				move.w	(sprite_height)r,d7
				lsr.w	#3,d7			;8x8cɕԐ
				subq.w	#2+1,d7			;g2
				for	d7			;c
					moveq.l	#1,d2			;BGeLXgXWBg1
					move.w	(screen_width)r,d6
					lsr.w	#3,d6			;8x8ɕԐ
					subq.w	#2+1,d6			;g2
					for	d6			;
						IOCS	_BGTEXTST
						addq.w	#1,d2			;BGeLXgXW
					next
					addq.w	#1,d3			;BGeLXgYW
				next
			;BACK-GROUND 0/1Ə
				moveq.l	#2*1,d2
				movea.l	d2,a2			;XW
				moveq.l	#BG_LINE,d3
				add.w	d5,d3
				move.w	(screen_height)r,d0
				if	<cmp.w (sprite_height)r,d0>,ne
					add.w	d3,d3
				endif
				add.w	d3,d3
				movea.l	d3,a3			;YW
			;		 B  A  C  K  -  G  R  O  U  N  D     0
				movestr	<9,10,11,12,13,14,15,16,17,18,19,20,21>,a4	;p^[ԍ
				dostart
					move.l	d5,d4
					addq.b	#2,d4			;pbgubN 2,3
					lsl.w	#8,d4
					if	<cmp.b #21,d0>,eq	;0/1
						add.b	d5,d0			;21(0)22(1)
					endif
					move.b	d0,d4			;pbgubN:16x16p^[ԍ
					lsl.b	#2,d4			;pbgubN:8x8p^[ԍ
					moveq.l	#4-1,d6			;,,E,E
					for	d6
						move.l	d5,d1			;BGeLXgGA 0,1
						moveq.l	#2,d2
						and.b	d4,d2
						lsr.w	#1,d2
						add.w	a2,d2			;BGeLXgXW
						moveq.l	#1,d3
						and.b	d4,d3
						add.w	a3,d3			;BGeLXgYW
						IOCS	_BGTEXTST
						addq.b	#1,d4			;8x8p^[ԍ
					next
					addq.w	#2,a2			;BGeLXgXW
				start
					moveq.l	#0,d0
					move.b	(a4)+,d0		;p^[ԍ
				while	ne
			;\ON
				move.l	d5,d1			;BGy[W 0,1
				move.l	d5,d2			;BGeLXgGA 0,1
				moveq.l	#1,d3			;\ON
				IOCS	_BGCTRLST
			;
				addq.w	#1,d5			;BGeLXgGA
			while	<cmp.w #1,d5>,ls
		else				;16x16/1024x1024x1
		;g̃p^[`
			moveq.l	#1,d1			;p^[ԍ 1
			moveq.l	#1,d2			;TCY 16x16
			lea.l	(bg_pattern_16x16)r,a1	;p^[f[^
			IOCS	_SP_DEFCG
		;g̃p^[œhׂ
			moveq.l	#0,d1			;BGeLXgGA 0
			move.w	#2<<8|1,d2		;pbgubN:p^[ԍ 2:1
			IOCS	_BGTEXTCL
		;gcē蔲
			moveq.l	#0,d1			;BGeLXgGA 0
			move.w	#0<<8|0,d4		;pbgubN:p^[ԍ 0:0
			moveq.l	#1,d3			;BGeLXgYWBg1
			move.w	(sprite_height)r,d7
			lsr.w	#4,d7			;16x16cɕԐ
			subq.w	#2+1,d7			;g2
			for	d7			;c
				moveq.l	#1,d2			;BGeLXgXWBg1
				move.w	(screen_width)r,d6
				lsr.w	#4,d6			;16x16ɕԐ
				subq.w	#2+1,d6			;g2
				for	d6			;
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next
		;BACK-GROUND 0Ə
			moveq.l	#1*1,d2
			move.l	d2,a2			;XW
			moveq.l	#BG_LINE,d3
			move.w	(screen_height)r,d0
			if	<cmp.w (sprite_height)r,d0>,ne
				add.w	d3,d3
			endif
			movea.l	d3,a3			;YW
		;		 B  A  C  K  -  G  R  O  U  N  D     0
			movestr	<9,10,11,12,13,14,15,16,17,18,19,20,21>,a4	;p^[ԍ
			dostart
				move.w	#2<<8,d4
				move.b	d0,d4			;pbgubN:p^[ԍ
				moveq.l	#0,d1			;BGeLXgGA 0
				move.w	a2,d2			;BGeLXgXW
				move.w	a3,d3			;BGeLXgYW
				IOCS	_BGTEXTST
				addq.w	#1,a2			;BGeLXgXW
			start
				moveq.l	#0,d0
				move.b	(a4)+,d0		;p^[ԍ
			while	ne
		;\ON
			moveq.l	#0,d1			;BGy[W 0
			moveq.l	#0,d2			;BGeLXgGA 0
			moveq.l	#1,d3			;\ON
			IOCS	_BGCTRLST
		endif
	endif

;L[͂҂Ăʃ[h𕜌
	IOCS	_B_CUROFF
	DOS	_GETC
	if	<cmp.b #27,d0>,eq	;ESCL[ꂽƂ
	;XvCgʂƃOtBbNʂOFFɂ
		moveq.l	#$0020,d1
		IOCS	_CRTMOD2
	;eLXgʂ
		moveq.l	#2,d1
		IOCS	_B_CLR_ST
	;eLXgpbg𕜌
		moveq.l	#3,d1
		moveq.l	#-2,d2
		IOCS	_TPALET
	else				;ESCL[ȊOꂽƂ
	;CRTorLCD[h𕜌
		if	<tst.b (save_to_sram)r>,eq	;CRTorLCD[hSRAMɕۑȂ
			if	<tst.b (saved_crtlcd)r>,eq	;CRT
				move.w	#$43FF,d1
			else				;LCD
				move.w	#$4CFF,d1
			endif
			IOCS	_CRTMOD			;CRTorLCD[h𕜌
		endif
	;OS̉ʃ[h𕜌
		move.l	#(16<<16)|$FFFF,-(sp)
		DOS	_CONCTRL
		move.w	d0,2(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
	endif
	IOCS	_B_CURON

;I
exit:
	DOS	_EXIT

;^CgƎgp@\ďI
usage_exit:
	lea.l	title_usage(pc),a0
	bsr	more
	goto	exit

;^CgƎgp@
title_usage:
	.dc.b	TITLE_STRING,13,10
	.dc.b	'IvV',13,10
	.dc.b	'  -l 0-1   CRTorLCD[hB0=CRT,1=LCD',13,10
	.dc.b	'  -m 0-47  ʃ[h',13,10
	.dc.b	'  -s       -lŎw肵CRTorLCD[hSRAMɕۑ',13,10
	.dc.b	'  ',13,10
	.dc.b	'  CRTMODʃTCY F y[W            ʃTCY      l      ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     0   1024x1024     16  1                                                        ',13,10
	.dc.b	'     4    512x512      16  4    CRT  31.500kHz  55.458Hz   512x512                  ',13,10
	.dc.b	'     8    512x512     256  2    LCD  35.341kHz  56.546Hz   512x512                  ',13,10
	.dc.b	'    12    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     1   1024x1024     16  1                                                        ',13,10
	.dc.b	'     5    512x512      16  4    CRT  15.980kHz  61.463Hz   512x480   C^[[X ',13,10
	.dc.b	'     9    512x512     256  2    LCD  35.341kHz  56.546Hz   512x480                  ',13,10
	.dc.b	'    13    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     2   1024x1024     16  1                                                        ',13,10
	.dc.b	'     6    512x512      16  4    CRT  31.500kHz  55.458Hz   256x256   X^2xǂ  ',13,10
	.dc.b	'    10    512x512     256  2    LCD  34.500kHz  55.200Hz   256x256   X^2xǂ  ',13,10
	.dc.b	'    14    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     3   1024x1024     16  1                                                        ',13,10
	.dc.b	'     7    512x512      16  4    CRT  15.980kHz  61.463Hz   256x240                  ',13,10
	.dc.b	'    11    512x512     256  2    LCD  34.500kHz  55.200Hz   256x240   X^2xǂ  ',13,10
	.dc.b	'    15    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    16   1024x1024     16  1    CRT  31.500kHz  55.458Hz   768x512                  ',13,10
	.dc.b	'    20    512x512     256  2    LCD  35.056kHz  56.090Hz   768x512                  ',13,10
	.dc.b	'    24    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    17   1024x1024     16  1    CRT  24.699kHz  53.116Hz  1024x424                  ',13,10
	.dc.b	'    21    512x512     256  2    LCD  35.056kHz  56.090Hz   768x600                  ',13,10
	.dc.b	'    25    512x512   65536  1                                 ό`                   ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    18   1024x1024     16  1    CRT  24.699kHz  53.116Hz  1024x848   C^[[X ',13,10
	.dc.b	'    22    512x512     256  2    LCD  35.056kHz  56.090Hz   768x1024  C^[[X ',13,10
	.dc.b	'    26    512x512   65536  1                                 ό`                   ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    19   1024x1024     16  1    CRT  31.500kHz  55.458Hz   640x480   VGAł͂Ȃ    ',13,10
	.dc.b	'    23    512x512     256  2    LCD  31.469kHz  59.940Hz   640x480   VGA            ',13,10
	.dc.b	'    27    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    28   1024x1024     16  1                                                        ',13,10
	.dc.b	'    29    512x512      16  4    CRT  31.963kHz  56.273Hz   384x256   X^2xǂ  ',13,10
	.dc.b	'    30    512x512     256  2    LCD  31.963kHz  51.141Hz   384x256   X^2xǂ  ',13,10
	.dc.b	'    31    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    32   1024x1024     16  1                                                        ',13,10
	.dc.b	'    33    512x512      16  4    CRT  31.500kHz  55.458Hz   512x512                  ',13,10
	.dc.b	'    34    512x512     256  2    LCD  35.056kHz  56.090Hz   512x512                  ',13,10
	.dc.b	'    35    512x512   65536  1                                `                  ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    36   1024x1024     16  1                                                        ',13,10
	.dc.b	'    37    512x512      16  4    CRT  31.963kHz  56.273Hz   256x256   X^2xǂ  ',13,10
	.dc.b	'    38    512x512     256  2    LCD  31.963kHz  51.141Hz   256x256   X^2xǂ  ',13,10
	.dc.b	'    39    512x512   65536  1                                `                  ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    40   1024x1024     16  1                                                        ',13,10
	.dc.b	'    41    512x512      16  4    CRT  31.500kHz  55.458Hz   512x256   X^2xǂ  ',13,10
	.dc.b	'    42    512x512     256  2    LCD  35.341kHz  56.546Hz   512x256   X^2xǂ  ',13,10
	.dc.b	'    43    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    44   1024x1024     16  1                                                        ',13,10
	.dc.b	'    45    512x512      16  4    CRT  31.500kHz  55.458Hz   512x256   X^2xǂ  ',13,10
	.dc.b	'    46    512x512     256  2    LCD  35.341kHz  56.546Hz   512x256   X^2xǂ  ',13,10
	.dc.b	'    47    512x512   65536  1                         XvCg512x512            ',13,10
	.dc.b	'  ',13,10
	.dc.b	0
	.even

;F
text_color:	dchsv	0,24,31
graphic_color:	dchsv	24,24,31
		dchsv	48,24,31
		dchsv	72,24,31
		dchsv	96,24,31
sprite_color:	dchsv	120,24,31
		dchsv	144,24,31
		dchsv	168,24,31

;BGp^[
bg_pattern_8x8:
	.dc.l	$00110011		;BG0
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000

	.dc.l	$00000000		;BG1
	.dc.l	$00000000
	.dc.l	$11001100
	.dc.l	$11001100
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$11001100
	.dc.l	$11001100

bg_pattern_16x16:
	.dc.l	$00110011		;
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000

	.dc.l	$00110011		;E
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00110011
	.dc.l	$00110011
	.dc.l	$00000000
	.dc.l	$00000000

;XvCgp^[
sprite_pattern:
	.dc.l	$00001111		;
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000

	.dc.l	$00001111		;E
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$00001111
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000
	.dc.l	$11110000

	.bss

save_to_sram:	.ds.b	1		;CRTorLCD[hSRAMɕۑ邩B0=Ȃ,-1=
saved_crtlcd:	.ds.b	1		;̉ʃ[h
screen_mode:	.ds.b	1		;ʃ[h
crtlcd_mode:	.ds.b	1		;CRTorLCD[hB0=CRT,-1=LCD
pages:		.ds.b	1		;OtBbNy[W
bg_size:	.ds.b	1		;BGTCYB0=8x8/512x512x2,-1=16x16/1024x1024x1
sprite_exists:	.ds.b	1		;XvCgʂ̗LB0=Ȃ,-1=
	.even
screen_width:	.ds.w	1		;ʂ̕
screen_height:	.ds.w	1		;ʂ̍
sprite_height:	.ds.w	1		;XvCgʂ̍
real_size:	.ds.w	1		;ʃTCY
palets:		.ds.l	1		;OtBbNF
font_buffer:	.ds.w	2+2+3*24	;tHgobt@
pattern_buffer:	.ds.l	8*4		;XvCgp^[obt@
string_buffer:	.ds.b	256		;obt@

	.text



;----------------------------------------------------------------
;-more-݂Ȃ當\
;<a0.l:
more::
	push	d0-d5/a0-a2
;W͂mF
	clr.l	-(sp)			;(0<<16)|0
	DOS	_IOCTRL
	addq.l	#4,sp
;<d0.b:W͂FCBtO
	and.b	#$81,d0			;LN^foCXAW
	goto	<cmp.b #$81,d0>,ne,90f	;W͂_CNgĂBmoreȂ
;Wo͂mF
	pea.l	1.w			;(0<<16)|1
	DOS	_IOCTRL
	addq.l	#4,sp
;<d0.b:Wo͂FCBtO
	and.b	#$82,d0			;LN^foCXAWo
	goto	<cmp.b #$82,d0>,ne,90f	;Wo͂_CNgĂBmoreȂ
;CONDRV.SYSmF
	move.w	#$0100+_KEY_INIT,-(sp)
	DOS	_INTVCG
	addq.l	#2,sp
	movea.l	d0,a1
	subq.l	#4,a1
	IOCS	_B_LPEEK
	goto	<cmp.l #'hmk*',d0>,eq,90f	;CONDRV.SYSgݍ܂ĂBmoreȂ
;ʂ̑傫mF
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	IOCS	_B_CONSOL
;<d2.l:E[̌W<<16|[̍sW
	move.w	d2,d3
	swap.w	d2
	addq.w	#1,d2
;<d2.w:ʂ̌
;<d3.w:[̍sWB-more-̍sʂ̍s
	gotoor	<cmp.w #8,d2>,lo,<tst.w d3>,eq,90f	;ʂBmoreȂB^u܂߂1ȏ㏑Ȃ΂ȂȂ̂8x1s
;y[W[v
	do
		move.l	#0,d4			;W
		move.l	#0,d5			;sW
		movea.l	a0,a2			;y[W擪
	;[v
		do
			movea.l	a0,a1			;擪
			move.b	(a0)+,d0		;1oCg
			if	eq			;00 I
				subq.l	#1,a0
				break
			elif	<cmp.b #$09,d0>,eq	;09 ^u
				moveq.l	#7,d1
				and.w	d4,d1
				subq.w	#8,d1
				neg.w	d1		;^ǔ
			elif	<cmp.b #$0A,d0>,eq	;0A s
				moveq.l	#0,d4		;[
				addq.w	#1,d5		;̍s
				break	<cmp.w d3,d5>,eq	;[By[WI
				continue
			elif	<cmp.b #$0C,d0>,eq	;0C y[W
				break
			elif	<cmp.b #$1F,d0>,ls	;01-08,0B,0D-1F 
				continue
			else				;20-FF
				do
					moveq.l	#1,d1			;p̌
					break	<tst.b d0>,pl		;20-7F AXL[
					breakand	<cmp.b #$A0,d0>,hs,<cmp.b #$DF,d0>,ls	;A0-DF pJ^Ji
					addq.l	#1,a0			;2oCg
					break	<cmp.b #$80,d0>,eq	;8000-80FF pЂ炪
					break	<cmp.b #$F0,d0>,hs	;F000-FFFF 1/4pApO
					moveq.l	#2,d1			;Sp̌
				while	f
			endif
			add.w	d1,d4			;\̌W
			if	<cmp.w d2,d4>,hi	;͂ݏo
				sub.w	d1,d4			;i݉߂߂
				movea.l	a1,a0
				addq.w	#1,d5			;̍s
				break	<cmp.w d3,d5>,eq	;[By[WI
				moveq.l	#0,d4			;[
			endif
		while	t
	;1y[W\
		move.l	a0,d0			;
		sub.l	a2,d0			;-擪=
		move.l	d0,-(sp)		;
		move.l	a2,-(sp)		;擪
		move.w	#1,-(sp)		;Wo
		DOS	_WRITE
		lea.l	10(sp),sp
	;ȂΏI
		break	<tst.b (a0)>,eq
	;KvȂΉs
		ifand	<tst.w d4>,ne,<cmp.w d2,d4>,ne	;[łE[łȂ
			bsr	printcrlf
		endif
	;-more-\
		pea.l	6.w
		pea.l	100f(pc)		;'-more-'
		move.w	#1,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
	;L[͂҂
		DOS	_GETC
		move.l	d0,d1
	;s
		bsr	printcrlf
	whileand	<cmp.b #$1B,d1>,ne,<cmp.b #'Q',d1>,ne,<cmp.b #'q',d1>,ne	;ESC܂QꂽƂ͏I
99:	pop
	rts

;moreȂ
90:	bsr	print
	goto	99b

100:	.dc.b	'-more-'
	.even

;----------------------------------------------------------------
;󔒂ǂݔ΂
;<a0.l:
;>d0.l:ŏ̋󔒈ȊO̕܂0
;>a0.l:ŏ̋󔒈ȊO̕܂0̈ʒu
;>z:ne=󔒈ȊO̕,eq=󔒈ȊO̕Ȃ
nextword::
	moveq.l	#0,d0
	do
		move.b	(a0)+,d0		;̕
		break	eq			;0ȂΏI
		redo	<cmp.b #' ',d0>,eq	;' 'ȂΌJԂ
	whileand	<cmp.b #9,d0>,hs,<cmp.b #13,d0>,ls	;\t\n\v\f\rȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	tst.l	d0
	rts

;----------------------------------------------------------------
;\
;<a0.l:
print::
	push	d0
	bsr	strlen
	move.l	d0,-(sp)
	move.l	a0,-(sp)
	move.w	#1,-(sp)
	DOS	_WRITE
	lea.l	(10,sp),sp
	pop
	rts

;----------------------------------------------------------------
;s\
printcrlf::
	move.l	a0,-(sp)
	lea.l	100f(pc),a0		;13,10
	bsr	print
	movea.l	(sp)+,a0
	rts

100:	.dc.b	13,10,0
	.even

;----------------------------------------------------------------
;10i̕𕄍Ȃɕϊ
;<a0.l:10i̕B擪̋󔒂͔F߂Ȃ
;>d0.l:(cĉƂ)ȂB(cŝƂ)0=10i̕Ȃ,-1=I[o[t[
;>a0.l:(cĉƂ)10i̎̈̕ʒuB(cŝƂ)ωȂ
;>z:(cĉƂ)eq=Ȃ0
;>v:(cŝƂ)vc=10i̕Ȃ,vs=I[o[t[
;>c:cs=10i̕Ȃ܂̓I[o[t[
stou::
	push	d1-d2/a1
	moveq.l	#0,d0			;Ȃ
	moveq.l	#0,d1			;
	movea.l	a0,a1			;Jnʒu
	dostart
		goto	<cmp.l #$1999999A,d0>,hs,stou_overflow	;10{I[o[t[
		move.l	d0,d2			;1{
		lsl.l	#2,d0			;4{
		add.l	d2,d0			;5{
		add.l	d0,d0			;10{
		add.l	d1,d0			;1
		goto	cs,stou_overflow	;I[o[t[
	start
		move.b	(a0)+,d1		;̕
		sub.b	#'0',d1			;ɂ
	whileand	<>,hs,<cmp.b #10,d1>,lo	;10i̕ȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	tst.l	d0			;vc,cc
	if	<cmpa.l a1,a0>,eq	;iłȂB10i̕Ȃ
		ori.b	#%00001,ccr		;vc,cs
	endif
	goto	stou_end

;I[o[t[Ƃ
stou_overflow:
	do
		move.b	(a0)+,d1		;̕
		sub.b	#'0',d1			;ɂ
	whileand	<>,hs,<cmp.b #10,d1>,lo	;10i̕ǂݔ΂
	subq.l	#1,a0			;i݉߂߂
	moveq.l	#-1,d0			;I[o[t[
	ori.b	#%00011,ccr		;vs,cs
stou_end:
	pop
	rts

;----------------------------------------------------------------
;Rs[
;<a0.l:Rs[
;<a1.l:Rs[
;>a0.l:Rs[0̈ʒu
;>a1.l:Rs[0̎̈ʒu
strcpy::
	do
		move.b	(a1)+,(a0)+
	while	ne			;0łȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	rts

;----------------------------------------------------------------
;̒𐔂
;<a0.l:
;>d0.l:
strlen::
	move.l	a0,d0			;d0=擪
	do
		tst.b (a0)+
	while	ne			;0łȂΌJԂ
	subq.l	#1,a0			;i݉߂߂Ba0=
	exg.l	d0,a0			;d0=,a0=擪
	sub.l	a0,d0			;d0=-擪=
	rts

;----------------------------------------------------------------
;ɂ
;<d0.b:
;>d0.b:
tolower::
	ifand	<cmp.b #'A',d0>,hs,<cmp.b #'Z',d0>,ls	;啶
		add.b	#'a'-'A',d0		;ɂ
	endif
	rts

;----------------------------------------------------------------
;32rbgȂ10i̕ɕϊ
;<d0.l:Ȃ
;<a0.l:obt@B10i̐̕擪
;>a0.l:10i̖̕0̈ʒu
utos::
	if	<tst.l d0>,eq		;0
		move.b	#'0',(a0)+
	else				;0ȊO
		push	d0-d2/a1
		lea.l	utos_table(pc),a1
		do
			move.l	(a1)+,d1
		while	<cmp.l d1,d0>,lo	;Ƃ܂ŐiށB[TvX
		do
			moveq.l	#'0'-1,d2
			do
				addq.b	#1,d2
				sub.l	d1,d0
			while	hs			;񐔂𐔂
			move.b	d2,(a0)+
			add.l	d1,d0			;߂߂
			move.l	(a1)+,d1
		while	ne
		pop
	endif
	clr.b	(a0)
	rts

utos_table::
	.dc.l	1000000000
	.dc.l	100000000
	.dc.l	10000000
	.dc.l	1000000
	.dc.l	100000
	.dc.l	10000
	.dc.l	1000
	.dc.l	100
	.dc.l	10
	.dc.l	1
	.dc.l	0



	.end
